Option Strict Off
Option Explicit On
Module Module3
	
	'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
	'   ICS Visual Basic Constants
	'   File:  ICSVB.BAS
	'   This module contains the variable declarations, constants and routines that
	'   are commonly used by most Visual Basic applications.
	'
	'   This file should be added to your Visual Basic project by choosing Add File
	'   from the Project menu.
	'
	'   Copyright 2004, ICS Electronics div Systems West, Inc.
	'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
	'Option Explicit
	
	Public BD As Short 'board number
    Public dev As Short 'units GPIB address, NI format
    Public addr As Short 'unit's GPIB adddress, NI format
	Public MODEL As Short 'unit ID
	Public bddev As Short 'current device handle
	Public NL As String 'new line
	Public Msg As String 'error message
	Public RetMsg As String
	Public Notice As String 'configuration message
	Public CmdStr As String
	Public UnTalk As String
	Public UnListen As String
	Public EventStatus As String
	Public Rdg As String
	Public NADDR As Short
	Public LSTNDEV As String
	Public TALKDEV As String
	Public priaddr As Short 'unit's primary address
	Public secaddr As Short 'unit's secondary address
	
	Public Sub gpiberr(ByRef Msg As String)
		Dim eevent As Object
		Dim SPOLL As Object
		'=============================================================================
		'                      Subroutine GPIBERR
		'  This subroutine will notify you that a NI-488.2 subroutine failed by
		'  printing an error message.  The status variable IBSTA% will also be
		'  printed in hexadecimal along with the mnemonic meaning of the bit positions.
		'  The status variable IBERR% will be printed in decimal along with the
		'  mnemonic meaning of the decimal value.  The status variable IBCNTL& will
		'  be printed in decimal.
		'
		'  The NI-488 function IBONL is called to disable the hardware and software.
		'=============================================================================
		Dim EMsg As String
		'Msg$ = Msg$ + NL + ", ibsta = &H" + Hex$(ibsta%) + " <" + NL
        Msg = Msg & ",  GPIB32Funcs.ibsta = &H" & Hex(GPIB32Funcs.ibsta) & " <"
        EMsg = ""
        eevent = 0
        SPOLL = 0
        If GPIB32Funcs.ibsta And GPIB32Funcs.EERR Then EMsg = EMsg & "ERR "
        If GPIB32Funcs.ibsta And GPIB32Funcs.TIMO Then EMsg = EMsg & "TIMO "
        If GPIB32Funcs.ibsta And GPIB32Funcs.EEND Then EMsg = EMsg & "END "
        If GPIB32Funcs.ibsta And GPIB32Funcs.SRQI Then EMsg = EMsg & "SRQI "
        If GPIB32Funcs.ibsta And GPIB32Funcs.RQS Then EMsg = EMsg & "RQS "
        If GPIB32Funcs.ibsta And GPIB32Funcs.SPOLL Then EMsg = EMsg & "SPOLL "
        If GPIB32Funcs.ibsta And eevent Then EMsg = EMsg & "EVENT "
        If GPIB32Funcs.ibsta And GPIB32Funcs.CMPL Then EMsg = EMsg & "CMPL "
        If GPIB32Funcs.ibsta And GPIB32Funcs.LOK Then EMsg = EMsg & "LOK "
        If GPIB32Funcs.ibsta And GPIB32Funcs.RREM Then EMsg = EMsg & "REM "
        If GPIB32Funcs.ibsta And GPIB32Funcs.CIC Then EMsg = EMsg & "CIC "
        If GPIB32Funcs.ibsta And GPIB32Funcs.AATN Then EMsg = EMsg & "ATN "
        If GPIB32Funcs.ibsta And GPIB32Funcs.TACS Then EMsg = EMsg & "TACS "
        If GPIB32Funcs.ibsta And GPIB32Funcs.LACS Then EMsg = EMsg & "LACS "
        If GPIB32Funcs.ibsta And GPIB32Funcs.DTAS Then EMsg = EMsg & "DTAS "
        If GPIB32Funcs.ibsta And GPIB32Funcs.DCAS Then EMsg = EMsg & "DCAS "
		'Msg = Msg + "  " + EMsg$ + " >" + " iberr = " + Str$(iberr%) + NL
        Msg = Msg & "  " & EMsg & " >, GPIB32Funcs.iberr = " & Str(GPIB32Funcs.iberr)
		
        If GPIB32Funcs.iberr = GPIB32Funcs.EDVR Then EMsg = " EDVR <Op System Error>"
        If GPIB32Funcs.iberr = GPIB32Funcs.ECIC Then EMsg = " ECIC <Not CIC>"
        If GPIB32Funcs.iberr = GPIB32Funcs.ENOL Then EMsg = " ENOL <No Listener>"
        If GPIB32Funcs.iberr = GPIB32Funcs.EADR Then EMsg = " EADR <Address error>"
        If GPIB32Funcs.iberr = GPIB32Funcs.EARG Then EMsg = " EARG <Invalid argument>"
        If GPIB32Funcs.iberr = GPIB32Funcs.ESAC Then EMsg = " ESAC <Not Sys Ctrlr>"
        If GPIB32Funcs.iberr = GPIB32Funcs.EABO Then EMsg = " EABO <Operation aborted>"
        If GPIB32Funcs.iberr = GPIB32Funcs.ENEB Then EMsg = " ENEB <No GPIB board>"
        If GPIB32Funcs.iberr = GPIB32Funcs.EOIP Then EMsg = " EOIP <Async I/O in prg>"
        If GPIB32Funcs.iberr = GPIB32Funcs.ECAP Then EMsg = " ECAP <No capability>"
        If GPIB32Funcs.iberr = GPIB32Funcs.EFSO Then EMsg = " EFSO <File sys. error>"
        If GPIB32Funcs.iberr = GPIB32Funcs.EBUS Then EMsg = " EBUS <Command error>"
        If GPIB32Funcs.iberr = GPIB32Funcs.ESTB Then EMsg = " ESTB <Status byte lost>"
        If GPIB32Funcs.iberr = GPIB32Funcs.ESRQ Then EMsg = " ESRQ <SRQ stuck on>"
        If GPIB32Funcs.iberr = GPIB32Funcs.ETAB Then EMsg = " ETAB <Table Overflow>"
		
        Msg = Msg & EMsg & ", GPIB32Funcs.ibcnt = " & Str(GPIB32Funcs.ibcntl)
		RetMsg = Msg
		'  Call the IBONL function to disable the hardware and software.
		'  ibonl call removed 2/13/04
		'Call ibonl(0, 0)
		
	End Sub
End Module